package com.akman.skintone;
// NIST-developed software is provided by NIST as a public service. You may use, copy and distribute copies of the software in any medium, provided that you keep intact this entire notice. You may improve, modify and create derivative works of the software or any portion of the software, and you may copy and distribute such modifications or works. Modified works should carry a notice stating that you changed the software and should note the date and nature of any such change. Please explicitly acknowledge the National Institute of Standards and Technology as the source of the software.

// NIST-developed software is expressly provided "AS IS." NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED, IN FACT OR ARISING BY OPERATION OF LAW, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY. NIST NEITHER REPRESENTS NOR WARRANTS THAT THE OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR-FREE, OR THAT ANY DEFECTS WILL BE CORRECTED. NIST DOES NOT WARRANT OR MAKE ANY REPRESENTATIONS REGARDING THE USE OF THE SOFTWARE OR THE RESULTS THEREOF, INCLUDING BUT NOT LIMITED TO THE CORRECTNESS, ACCURACY, RELIABILITY, OR USEFULNESS OF THE SOFTWARE.

// You are solely responsible for determining the appropriateness of using and distributing the software and you assume all risks associated with its use, including but not limited to the risks and costs of program errors, compliance with applicable laws, damage to or loss of data, programs or equipment, and the unavailability or interruption of operation. This software is not intended to be used in any situation where a failure could cause risk of injury or damage to property. The software developed by NIST employees is not subject to copyright protection within the United States.



// ================================================================
//
// Author: tjb3
// Date: Apr 7, 2014 6:03:46 PM EST
//
// Time-stamp: <Apr 7, 2014 6:03:46 PM tjb3>
//
//
// ================================================================



import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_ASYNC_ENGINE_COUNT;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_CAN_MAP_HOST_MEMORY;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_CLOCK_RATE;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_COMPUTE_MODE;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_CONCURRENT_KERNELS;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_ECC_ENABLED;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_GLOBAL_MEMORY_BUS_WIDTH;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_INTEGRATED;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_KERNEL_EXEC_TIMEOUT;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_L2_CACHE_SIZE;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_LAYERED_LAYERS;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_LAYERED_WIDTH;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_WIDTH;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_HEIGHT;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_LAYERED_HEIGHT;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_LAYERED_LAYERS;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_LAYERED_WIDTH;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_WIDTH;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_DEPTH;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_HEIGHT;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_WIDTH;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_X;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Y;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Z;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_X;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Y;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Z;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_PITCH;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_REGISTERS_PER_BLOCK;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_SHARED_MEMORY_PER_BLOCK;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_THREADS_PER_BLOCK;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MAX_THREADS_PER_MULTIPROCESSOR;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MEMORY_CLOCK_RATE;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_MULTIPROCESSOR_COUNT;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_PCI_BUS_ID;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_PCI_DEVICE_ID;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_PCI_DOMAIN_ID;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_SURFACE_ALIGNMENT;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_TCC_DRIVER;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_TEXTURE_ALIGNMENT;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_TOTAL_CONSTANT_MEMORY;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_UNIFIED_ADDRESSING;
import static jcuda.driver.CUdevice_attribute.CU_DEVICE_ATTRIBUTE_WARP_SIZE;
import static jcuda.driver.JCudaDriver.cuModuleGetFunction;
import static jcuda.driver.JCudaDriver.cuModuleLoadData;
import static jcuda.nvrtc.JNvrtc.nvrtcCompileProgram;
import static jcuda.nvrtc.JNvrtc.nvrtcCreateProgram;
import static jcuda.nvrtc.JNvrtc.nvrtcDestroyProgram;
import static jcuda.nvrtc.JNvrtc.nvrtcGetPTX;
import static jcuda.nvrtc.JNvrtc.nvrtcGetProgramLog;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import javax.swing.JOptionPane;

import jcuda.driver.CUcontext;
import jcuda.driver.CUdevice;
import jcuda.driver.CUfunction;
import jcuda.driver.CUmodule;
import jcuda.driver.JCudaDriver;
import jcuda.nvrtc.nvrtcProgram;

/**
 * Utility class for initializing JCUDA.
 *
 * @author Tim Blattner
 * @version 1.0
 */
public class CudaUtils {
	
  private static final int CHAR_LEN = 1024;

  private static boolean initialized = false;
  private static CUdevice[] devices = null;
  private static CUcontext[] contexts = null;


  /**
   * Checks if GPUs have been initialized or not
   *
   * @return true if GPUs have been initialized, otherwise false
   */
  public static boolean isGPUInitialized() {
    return initialized;
  }

  /**
   * Gets the GPU contexts
   *
   * @return the GPU contexts
   */
  public static CUcontext[] getGPUContexts() {
    return contexts;
  }


  /**
   * Returns a short description of the given CUdevice_attribute constant Obtained from JCUDA
   * deviceQuery example: http://www.jcuda.org/samples/JCudaDeviceQuery.java
   *
   * @return A short description of the given constant
   */
  private static String getAttributeDescription(int attribute) {
    switch (attribute) {
      case CU_DEVICE_ATTRIBUTE_MAX_THREADS_PER_BLOCK:
        return "Maximum number of threads per block";
      case CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_X:
        return "Maximum x-dimension of a block";
      case CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Y:
        return "Maximum y-dimension of a block";
      case CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Z:
        return "Maximum z-dimension of a block";
      case CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_X:
        return "Maximum x-dimension of a grid";
      case CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Y:
        return "Maximum y-dimension of a grid";
      case CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Z:
        return "Maximum z-dimension of a grid";
      case CU_DEVICE_ATTRIBUTE_MAX_SHARED_MEMORY_PER_BLOCK:
        return "Maximum shared memory per thread block in bytes";
      case CU_DEVICE_ATTRIBUTE_TOTAL_CONSTANT_MEMORY:
        return "Total constant memory on the device in bytes";
      case CU_DEVICE_ATTRIBUTE_WARP_SIZE:
        return "Warp size in threads";
      case CU_DEVICE_ATTRIBUTE_MAX_PITCH:
        return "Maximum pitch in bytes allowed for memory copies";
      case CU_DEVICE_ATTRIBUTE_MAX_REGISTERS_PER_BLOCK:
        return "Maximum number of 32-bit registers per thread block";
      case CU_DEVICE_ATTRIBUTE_CLOCK_RATE:
        return "Clock frequency in kilohertz";
      case CU_DEVICE_ATTRIBUTE_TEXTURE_ALIGNMENT:
        return "Alignment requirement";
      case CU_DEVICE_ATTRIBUTE_MULTIPROCESSOR_COUNT:
        return "Number of multiprocessors on the device";
      case CU_DEVICE_ATTRIBUTE_KERNEL_EXEC_TIMEOUT:
        return "Whether there is a run time limit on kernels";
      case CU_DEVICE_ATTRIBUTE_INTEGRATED:
        return "Device is integrated with host memory";
      case CU_DEVICE_ATTRIBUTE_CAN_MAP_HOST_MEMORY:
        return "Device can map host memory into CUDA address space";
      case CU_DEVICE_ATTRIBUTE_COMPUTE_MODE:
        return "Compute mode";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_WIDTH:
        return "Maximum 1D texture width";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_WIDTH:
        return "Maximum 2D texture width";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_HEIGHT:
        return "aximum 2D texture height";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_WIDTH:
        return "Maximum 3D texture width";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_HEIGHT:
        return "Maximum 3D texture height";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_DEPTH:
        return "Maximum 3D texture depth";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_LAYERED_WIDTH:
        return "Maximum 2D layered texture width";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_LAYERED_HEIGHT:
        return "Maximum 2D layered texture height";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_LAYERED_LAYERS:
        return "Maximum layers in a 2D layered texture";
      case CU_DEVICE_ATTRIBUTE_SURFACE_ALIGNMENT:
        return "Alignment requirement for surfaces";
      case CU_DEVICE_ATTRIBUTE_CONCURRENT_KERNELS:
        return "Device can execute multiple kernels concurrently";
      case CU_DEVICE_ATTRIBUTE_ECC_ENABLED:
        return "Device has ECC support enabled";
      case CU_DEVICE_ATTRIBUTE_PCI_BUS_ID:
        return "PCI bus ID of the device";
      case CU_DEVICE_ATTRIBUTE_PCI_DEVICE_ID:
        return "PCI device ID of the device";
      case CU_DEVICE_ATTRIBUTE_TCC_DRIVER:
        return "Device is using TCC driver model";
      case CU_DEVICE_ATTRIBUTE_MEMORY_CLOCK_RATE:
        return "Peak memory clock frequency in kilohertz";
      case CU_DEVICE_ATTRIBUTE_GLOBAL_MEMORY_BUS_WIDTH:
        return "Global memory bus width in bits";
      case CU_DEVICE_ATTRIBUTE_L2_CACHE_SIZE:
        return "Size of L2 cache in bytes";
      case CU_DEVICE_ATTRIBUTE_MAX_THREADS_PER_MULTIPROCESSOR:
        return "Maximum resident threads per multiprocessor";
      case CU_DEVICE_ATTRIBUTE_ASYNC_ENGINE_COUNT:
        return "Number of asynchronous engines";
      case CU_DEVICE_ATTRIBUTE_UNIFIED_ADDRESSING:
        return "Device shares a unified address space with the host";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_LAYERED_WIDTH:
        return "Maximum 1D layered texture width";
      case CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_LAYERED_LAYERS:
        return "Maximum layers in a 1D layered texture";
      case CU_DEVICE_ATTRIBUTE_PCI_DOMAIN_ID:
        return "PCI domain ID of the device";
    }
    return "(UNKNOWN ATTRIBUTE)";
  }

  /**
   * Returns a list of all CUdevice_attribute constants Obtained from:
   * http://www.jcuda.org/samples/JCudaDeviceQuery.java
   *
   * @return A list of all CUdevice_attribute constants
   */
  private static List<Integer> getAttributes() {
    List<Integer> list = new ArrayList<Integer>();
    list.add(CU_DEVICE_ATTRIBUTE_MAX_THREADS_PER_BLOCK);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_X);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Y);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_BLOCK_DIM_Z);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_X);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Y);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_GRID_DIM_Z);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_SHARED_MEMORY_PER_BLOCK);
    list.add(CU_DEVICE_ATTRIBUTE_TOTAL_CONSTANT_MEMORY);
    list.add(CU_DEVICE_ATTRIBUTE_WARP_SIZE);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_PITCH);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_REGISTERS_PER_BLOCK);
    list.add(CU_DEVICE_ATTRIBUTE_CLOCK_RATE);
    list.add(CU_DEVICE_ATTRIBUTE_TEXTURE_ALIGNMENT);
    list.add(CU_DEVICE_ATTRIBUTE_MULTIPROCESSOR_COUNT);
    list.add(CU_DEVICE_ATTRIBUTE_KERNEL_EXEC_TIMEOUT);
    list.add(CU_DEVICE_ATTRIBUTE_INTEGRATED);
    list.add(CU_DEVICE_ATTRIBUTE_CAN_MAP_HOST_MEMORY);
    list.add(CU_DEVICE_ATTRIBUTE_COMPUTE_MODE);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_WIDTH);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_WIDTH);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_HEIGHT);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_WIDTH);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_HEIGHT);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE3D_DEPTH);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_LAYERED_WIDTH);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_LAYERED_HEIGHT);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE2D_LAYERED_LAYERS);
    list.add(CU_DEVICE_ATTRIBUTE_SURFACE_ALIGNMENT);
    list.add(CU_DEVICE_ATTRIBUTE_CONCURRENT_KERNELS);
    list.add(CU_DEVICE_ATTRIBUTE_ECC_ENABLED);
    list.add(CU_DEVICE_ATTRIBUTE_PCI_BUS_ID);
    list.add(CU_DEVICE_ATTRIBUTE_PCI_DEVICE_ID);
    list.add(CU_DEVICE_ATTRIBUTE_TCC_DRIVER);
    list.add(CU_DEVICE_ATTRIBUTE_MEMORY_CLOCK_RATE);
    list.add(CU_DEVICE_ATTRIBUTE_GLOBAL_MEMORY_BUS_WIDTH);
    list.add(CU_DEVICE_ATTRIBUTE_L2_CACHE_SIZE);
    list.add(CU_DEVICE_ATTRIBUTE_MAX_THREADS_PER_MULTIPROCESSOR);
    list.add(CU_DEVICE_ATTRIBUTE_ASYNC_ENGINE_COUNT);
    list.add(CU_DEVICE_ATTRIBUTE_UNIFIED_ADDRESSING);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_LAYERED_WIDTH);
    list.add(CU_DEVICE_ATTRIBUTE_MAXIMUM_TEXTURE1D_LAYERED_LAYERS);
    list.add(CU_DEVICE_ATTRIBUTE_PCI_DOMAIN_ID);
    return list;
  }

  /**
   * Creates a String from a zero-terminated string in a byte array Obtained from:
   * http://www.jcuda.org/samples/JCudaDeviceQuery.java
   *
   * @param bytes The byte array
   * @return The String
   */
  private static String createString(byte bytes[]) {
    StringBuilder sb = new StringBuilder();
    for (int i = 0; i < bytes.length; i++) {
      char c = (char) bytes[i];
      if (c == 0) {
        break;
      }
      sb.append(c);
    }
    return sb.toString();
  }


  public static long getFreeCudaMemory(CUcontext context) {
    JCudaDriver.cuCtxSetCurrent(context);
    long[] free = new long[1];
    long[] total = new long[1];
    JCudaDriver.cuMemGetInfo(free, total);

    return free[0];
  }
  
	/**
	 * Read the resource with the given name, and return its contents as a string.
	 * Returns <code>null</code> if the resource cannot be found or read.
	 * 
	 * @param name The name of the resource
	 * @return The contents of the resource
	 */
	public static String readResourceAsString(String name) {
		ClassLoader classLoader = SkinTone.class.getClassLoader();
		File file = new File(classLoader.getResource(name).getFile());
		InputStream inputStream = null;
		try {
			inputStream = new FileInputStream(file);
		} catch (FileNotFoundException e1) {
		}
		if (inputStream == null) {
			JOptionPane.showMessageDialog(null, "Resource was not found:" + name, "Error", JOptionPane.ERROR_MESSAGE);
			return null;
		}
		try {
			return readStreamAsString(inputStream);
		} catch (IOException e) {
			JOptionPane.showMessageDialog(null, "Could not read the resource:" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
			return null;
		}
	}

	/**
	 * Read the contents of the given input stream, and return it as a string
	 * 
	 * @param inputStream The input stream
	 * @return The string
	 * @throws IOException If the input cannot be read
	 */
	public static String readStreamAsString(InputStream inputStream) throws IOException {
		try (Scanner s = new Scanner(inputStream)) {
			Scanner scanner = s.useDelimiter("\\A");
			if (scanner.hasNext()) {
				return s.next();
			}
			throw new IOException("Could not read input stream");
		}
	}
	
	/**
	 * Create the CUDA function object for the kernel function with the given name
	 * that is contained in the given source code
	 * 
	 * @param sourceCode The source code
	 * @param kernelName The kernel function name
	 * @return
	 */
	public static CUfunction createFunction(String sourceCode, String kernelName) {
		// Use the NVRTC to create a program by compiling the source code
		nvrtcProgram program = new nvrtcProgram();
		nvrtcCreateProgram(program, sourceCode, null, 0, null, null);
		nvrtcCompileProgram(program, 0, null);

		// Obtain the compilation log, and print it if it is not empty
		// (for the case there are any warnings)
		String programLog[] = new String[1];
		nvrtcGetProgramLog(program, programLog);
		String log = programLog[0].trim();
		if (!log.isEmpty()) {
			System.err.println("Program compilation log:\n" + log);
		}

		// Obtain the PTX ("CUDA Assembler") code of the compiled program
		String[] ptx = new String[1];
		nvrtcGetPTX(program, ptx);
		nvrtcDestroyProgram(program);

		// Create a CUDA module from the PTX code
		CUmodule module = new CUmodule();
		cuModuleLoadData(module, ptx[0]);

		// Obtain the function pointer to the kernel function from the module
		CUfunction function = new CUfunction();
		cuModuleGetFunction(function, module, kernelName);

		return function;
	}
	
	/**
	 * The extension of the given file name is replaced with "ptx". If the file with
	 * the resulting name does not exist, it is compiled from the given file using
	 * NVCC. The name of the PTX file is returned.
	 *
	 * @param cuFileName The name of the .CU file
	 * @return The name of the PTX file
	 * @throws IOException If an I/O error occurs
	 */
	public static String preparePtxFile(String cuFileName) throws IOException {
		int endIndex = cuFileName.lastIndexOf('.');
		if (endIndex == -1) {
			endIndex = cuFileName.length() - 1;
		}
		String ptxFileName = cuFileName.substring(0, endIndex + 1) + "ptx";
		File ptxFile = new File(ptxFileName);
		if (ptxFile.exists()) {
			return ptxFileName;
		}

		File cuFile = new File(cuFileName);
		if (!cuFile.exists()) {
			throw new IOException("Input file not found: " + cuFileName);
		}
		String modelString = "-m" + System.getProperty("sun.arch.data.model");
		String command = "nvcc " + modelString + " -ptx " + cuFile.getPath() + " -o " + ptxFileName;

		System.out.println("Executing\n" + command);
		Process process = Runtime.getRuntime().exec(command);

		String errorMessage = new String(toByteArray(process.getErrorStream()));
		String outputMessage = new String(toByteArray(process.getInputStream()));
		int exitValue = 0;
		try {
			exitValue = process.waitFor();
		} catch (InterruptedException e) {
			Thread.currentThread().interrupt();
			throw new IOException("Interrupted while waiting for nvcc output", e);
		}

		if (exitValue != 0) {
			System.out.println("nvcc process exitValue " + exitValue);
			System.out.println("errorMessage:\n" + errorMessage);
			System.out.println("outputMessage:\n" + outputMessage);
			throw new IOException("Could not create .ptx file: " + errorMessage);
		}

		System.out.println("Finished creating PTX file");
		return ptxFileName;
	}
	
	/**
	 * Fully reads the given InputStream and returns it as a byte array
	 *
	 * @param inputStream The input stream to read
	 * @return The byte array containing the data from the input stream
	 * @throws IOException If an I/O error occurs
	 */
	private static byte[] toByteArray(InputStream inputStream) throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		byte buffer[] = new byte[8192];
		while (true) {
			int read = inputStream.read(buffer);
			if (read == -1) {
				break;
			}
			baos.write(buffer, 0, read);
		}
		return baos.toByteArray();
	}


}
